<?php
namespace Myquest\Controller;

use Doctrine\DBAL\Connection;
use Util\Utilities;
use Zeedhi\Framework\DataSource\DataSet;

class DeviceController
{

    protected $entityManager;

    public function __construct($entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getDevices($request, $response)
    {
        $sql = "SELECT NRDISPOSITIVOMYQ, NMDISPOSITIVOMYQ FROM DISPOSITIVOMYQ WHERE TO_CHAR(NRLOCALPESQ) = TO_CHAR(:NRLOCALPESQ)";
        $conn = $this->entityManager->getConnection();
        $row = $request->getRow();
        $params = [
            'NRLOCALPESQ' => $row['NRLOCALPESQ']
        ];
    
        try {
            $statement = $conn->prepare($sql);
            $statement->execute($params);
            $result = $statement->fetchAll();
        } catch (\Exception $e) {
            $result = [];
        }
        $response->addDataSet(new DataSet('devices', $result));
    }

    
    public function insertDevice($request, $response)
    {
        $sql = "BEGIN 
                    INSERT INTO MONITORDISPMYQ(NRDISPOSITIVOMYQ, DSFUNCAO, DSRESOLUCAO) 
                    VALUES (:NRDISPOSITIVOMYQ, :DSFUNCAO, :DSRESOLUCAO); 
                EXCEPTION 
                    WHEN DUP_VAL_ON_INDEX THEN 
                        UPDATE MONITORDISPMYQ 
                        SET DTULTATU = SYSDATE, DSRESOLUCAO = :DSRESOLUCAO, DSFUNCAO = :DSFUNCAO
                        WHERE NRDISPOSITIVOMYQ = :NRDISPOSITIVOMYQ;
                END;";
        
        $conn = $this->entityManager->getConnection();
        $row = $request->getRow();
        $params = [
            'NRDISPOSITIVOMYQ' => $row['NRDISPOSITIVOMYQ'],
            'DSFUNCAO' => $row['DSFUNCAO'],
            'DSRESOLUCAO' => $row['DSRESOLUCAO']
        ];
    
        try {
            $statement = $conn->prepare($sql);
            $statement->execute($params);
        } catch (\Exception $e) {
        }
    }

    
}